/* Barcode scanning (wand, flexible timing), supports interleaved 2 of 5.
 * Specifically, this script has the following requirements on barcodes:
 *  - symbology: interleaved 2 of 5
 *  - 4 or 6 (numeric) characters; set with constant "barcode_digits"
 *  - no checksum, but you may use the last digit as a checksum
 */

const barcode_digits = 4
#include "barcode.inc"

const numdigits = 4

const wand_data = 14    /* data pin for the barcode wand */
const wand_power= 15    /* power pin for the barcode wand */

new cur_volume = 100

main()
    {
    barcode_init wand_data, _, wand_power
    }

changevolume(delta)
    {
    cur_volume = clamp(cur_volume + delta, 50, 100)
    setvolume cur_volume
    if (audiostatus() == Stopped)
        play !"success.mp3"
    }

barcode(code)
    {
    switch (code)
        {
        case 0001:
            stop
        case 0010:
            changevolume 3
        case 0011:
            changevolume -3
        default:
            {
            new str[20 char]
            strformat str, _, true, !"t%d.mp3", code
            if (fexist(str))
                play str
            else if (audiostatus() == Stopped)
                play !"failure.mp3"
            }
        }
    }
